include \masm32\include\masm32rt.inc

    .data
	oexParenthWnd		dd	0
	oexFieldhWnds		dd	0
    .code

oex2DThread	PROC    USES esi edi	oexParam:DWORD

	LOCAL msg:MSG

	invoke CoInitialize, 0

	mov ebx, alloc(SIZEOF WNDCLASSEX)

	mov [ebx].WNDCLASSEX.cbSize, SIZEOF WNDCLASSEX
	mov [ebx].WNDCLASSEX.lpfnWndProc, OFFSET oex2DThreadMsgProc
	mov [ebx].WNDCLASSEX.hInstance, 400000h
	mov [ebx].WNDCLASSEX.lpszClassName, chr$("P2D")
	mov [ebx].WNDCLASSEX.hCursor, rv(LoadCursor,NULL,IDC_ARROW)

	invoke RegisterClassEx, ebx

	mov oexParenthWnd, rv(CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, chr$("P2D"), chr$("P2D"), WS_EX_OVERLAPPEDWINDOW or WS_VISIBLE, 0, 0, 800, 600, 0, NULL, 400000h, NULL)

	.while 1
		invoke GetMessage,ADDR msg,0,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg
	.endw

	xor eax, eax

	ret

oex2DThread	ENDP

oex2DThreadMsgProc	PROC    USES ebx esi edi    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	.if uMsg == WM_CREATE
		mrm oexParenthWnd, hWnd

		mov oexFieldhWnds, alloc(1024)
		mov esi, eax

		mov [esi], rv(CreateWindowEx, WS_EX_CLIENTEDGE, chr$("EDIT"), chr$("text"), WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL, 144, 0, 256, 44, hWnd, 998, 400000h, 0)
		mov [esi+4], rv(CreateWindowEx, WS_EX_CLIENTEDGE, chr$("EDIT"), chr$("text"), WS_VISIBLE or WS_CHILDWINDOW or ES_AUTOHSCROLL, 144, 44, 256, 44, hWnd, 999, 400000h, 0)
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("BUTTON"), chr$("UpdateWindow (Fails)"), WS_TABSTOP or WS_VISIBLE or WS_CHILD or BS_DEFPUSHBUTTON, 144, 76, 256, 44, hWnd, 500, 400000h, 0
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("BUTTON"), chr$("Show/Hide (Works)"), WS_TABSTOP or WS_VISIBLE or WS_CHILD or BS_DEFPUSHBUTTON, 144, 108, 256, 44, hWnd, 501, 400000h, 0
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, chr$("BUTTON"), chr$("Exit"), WS_TABSTOP or WS_VISIBLE or WS_CHILD or BS_DEFPUSHBUTTON, 144, 140, 256, 44, hWnd, 502, 400000h, 0

		invoke SetFocus, hWnd
	.elseif uMsg == WM_COMMAND
		mov eax, wParam
		mov edx, eax
		shr edx, 16

		.if dx == BN_CLICKED && ax == 500

			mov esi, oexFieldhWnds
			.while DWORD PTR [esi]
				invoke DestroyWindow, [esi]
				add esi, 4
			.endw

			invoke InvalidateRect, hWnd, 0, TRUE
			invoke UpdateWindow, hWnd

		.elseif dx == BN_CLICKED && ax == 501

			mov esi, oexFieldhWnds
			.while DWORD PTR [esi]
				invoke DestroyWindow, [esi]
				add esi, 4
			.endw

			invoke ShowWindow, hWnd, SW_HIDE
			invoke ShowWindow, hWnd, SW_SHOW

		.elseif dx == BN_CLICKED && ax == 502
			invoke SendMessage, hWnd, WM_CLOSE, 0, 0
		.endif

	.elseif uMsg==WM_PARENTNOTIFY
		mov eax, wParam
		mov edx, eax
		shr edx, 16

		.if ax == 1
			invoke MessageBox,str$(edx),chr$("Control Created"),chr$("Action"),MB_OK
		.elseif ax == 2
			invoke MessageBox,str$(edx),chr$("Control Deleted"),chr$("Action"),MB_OK
		.endif
		xor eax, eax
		ret
	.elseif uMsg == WM_CLOSE
		invoke DestroyWindow, hWnd
	.elseif uMsg == WM_DESTROY
		invoke PostQuitMessage, 0
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	invoke DefWindowProc,hWnd,uMsg,wParam,lParam

	xor eax, eax

	ret

oex2DThreadMsgProc	ENDP

start:
;==============================================================================
    invoke GetModuleHandle, NULL

	invoke oex2DThread, 0

end start